/****************************************************************************
 * This file is part of the project AqHome.
 * AqHome (c) by 2023 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "aqhome/msg/msg_value.h"

#include <gwenhywfar/misc.h>
#include <gwenhywfar/list.h>
#include <gwenhywfar/error.h>
#include <gwenhywfar/debug.h>




uint32_t AQH_ValueMsg_GetTimestamp(const GWEN_MSG *msg)
{
  return GWEN_Msg_GetUint32At(msg, AQH_MSG_OFFS_ALL_DATA_BEGIN+AQH_MSG_OFFS_VALUE_TIMESTAMP, 0);
}



uint8_t AQH_ValueMsg_GetValueId(const GWEN_MSG *msg)
{
  return GWEN_Msg_GetUint8At(msg, AQH_MSG_OFFS_ALL_DATA_BEGIN+AQH_MSG_OFFS_VALUE_VALUEID, 0);
}



uint8_t AQH_ValueMsg_GetValueType(const GWEN_MSG *msg)
{
  return GWEN_Msg_GetUint8At(msg, AQH_MSG_OFFS_ALL_DATA_BEGIN+AQH_MSG_OFFS_VALUE_VALUETYPE, 0);
}



const char *AQH_ValueMsg_GetValueTypeName(const GWEN_MSG *msg)
{
  uint8_t t;

  t=AQH_ValueMsg_GetValueType(msg);
  switch(t) {
  case AQH_MSG_VALUE_TYPE_TEMP:     return "temperature";
  case AQH_MSG_VALUE_TYPE_HUMIDITY: return "humidity";
  default:                          break;
  }
  return "unknown";
}



double AQH_ValueMsg_GetValue(const GWEN_MSG *msg)
{
  if ((AQH_NodeMsg_GetMsgType(msg)==AQH_MSG_TYPE_VALUE) &&
      (GWEN_Msg_GetBytesInBuffer(msg)>=AQH_MSG_VALUE_MINSIZE)) {
    const uint8_t *ptr;
    double value;
    double denom;
    uint16_t intDenom;

    ptr=GWEN_Msg_GetConstBuffer(msg)+AQH_MSG_OFFS_ALL_DATA_BEGIN;
    value=(double)((ptr[AQH_MSG_OFFS_VALUE_VALUE])+(ptr[AQH_MSG_OFFS_VALUE_VALUE+1]<<8));
    intDenom=(ptr[AQH_MSG_OFFS_VALUE_DENOM])+(ptr[AQH_MSG_OFFS_VALUE_DENOM+1]<<8);
    denom=(double)(intDenom);
    if (intDenom==0)
      denom=1.0;
    return (double)(value/denom);

  }
  return 0.0;
}



void AQH_ValueMsg_DumpToBuffer(const GWEN_MSG *msg, GWEN_BUFFER *dbuf, const char *sText)
{
  if ((AQH_NodeMsg_GetMsgType(msg)==AQH_MSG_TYPE_VALUE) &&
      (GWEN_Msg_GetBytesInBuffer(msg)>=AQH_MSG_VALUE_MINSIZE)) {
    GWEN_Buffer_AppendArgs(dbuf, "0x%02x->0x%02x: VALUE %s (timestamp=0x%08x, value_id=0x%02x type=%s value=%f)\n",
                           AQH_NodeMsg_GetSourceAddress(msg),
                           AQH_NodeMsg_GetDestAddress(msg),
                           sText,
                           (unsigned int) AQH_ValueMsg_GetTimestamp(msg),
                           AQH_ValueMsg_GetValueId(msg),
                           AQH_ValueMsg_GetValueTypeName(msg),
                           AQH_ValueMsg_GetValue(msg));
  }
}





